package edu.byu.hbll.callnumber;

import java.math.BigDecimal;
import java.util.Objects;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * CallNumber implementation representing a Library of Congress (LC) call number.
 *
 * <p>In addition to satisfying the requirements of the CallNumber interface, LCCallNumber also
 * attempts to parse the various components of an LC call number and make them available discretely
 * through class-specific methods.
 *
 * <p>See http://www.loc.gov/catdir/cpso/lcc.html for information about the underlying
 * classification scheme.
 */
// I'm suppressing this checkstyle violation because this is an existing library and backwards
// compatibility should be maintained.
@SuppressWarnings("checkstyle:AbbreviationAsWordInName")
public final class LCCallNumber implements CallNumber {

  /** Serialization version. */
  private static final long serialVersionUID = 1L;

  /**
   * The regular expression used to parse an LC Call Number into its component values.
   *
   * <p>This regular expression is derived from logic originally authored and copyrighted by Bill
   * Dueber (https://github.com/billdueber) and available at:
   * https://github.com/libraryhackers/library-callnumber-lc. The README file accompanying the
   * original software includes the following statement regarding licensing and redistribution:
   * "This program is free software; you can redistribute it and/or modify it under the same terms
   * as Perl itself."
   *
   * <p>Therefore, in accordance with Perl's Artistic License, we have included the full text of the
   * Artistic License in the LICENSE file included in this repository. The following modifications
   * were made to the original regular expression:
   *
   * <ul>
   *   <li>Removed the special notation for call numbers starting with "VIDEO-D", "DVD-ROM",
   *       "CD-ROM", and "TAPE-C"
   *   <li>Changed the display/format of the regular expression to make it more concise
   * </ul>
   */
  public static final Pattern LC_CALLNUMBER_PATTERN =
      Pattern.compile(
          "^\\s*([A-Z]{1,3})" // subject class
              + "\\s*(?:(\\d+)(?:\\s*?\\.\\s*?(\\d+))?)?" // optional subject numbers with optional
              // decimal point
              + "\\s*(\\d+[stndrh]*)?" // optional extra numbering including suffixes (1st, 2nd,
              // etc.)
              + "\\s*(?:(\\.)?\\s*([A-Z]+)\\s*(\\d+):?([A-Z]*|\\Z)?)?" // cutter 1
              + "\\s*(?:\\.?\\s*([A-Z])\\s*(\\d+):?([A-Z]*|\\Z)?)?" // cutter 2
              + "\\s*(?:\\.?\\s*([A-Z])\\s*(\\d+):?([A-Z]*|\\Z)?)?" // cutter 3
              + "(\\s+.+?)?\\s*$", // everything else
          Pattern.CASE_INSENSITIVE);

  /** The general subject area/class of the call number. */
  private final String subjectClass;

  /** A more specific subject number within the general subject class. */
  private final BigDecimal subjectNumber;

  /** Optional text between the subject number and the cutters. */
  private final String preCutter;

  /** The first cutter. */
  private final String cutter1;

  /** The second cutter. */
  private final String cutter2;

  /** The third cutter. */
  private final String cutter3;

  /** All text following the cutters. */
  private final String postCutter;

  /** The human-friendly normalized representation of the LC call number. */
  private final String normalization;

  /** The (not-human-friendly) sortable representation of the LC call number. */
  private final String sortKey;

  /**
   * Constructs a new instance using the provided string as the template.
   *
   * @param str the call number string to use as the template (note that this should be a normalized
   *     or semi-normal representation of an LC Call Number, NOT a sortKey generated by an existing
   *     LCCallNumber instance).
   * @throws NullPointerException if the provided string is null
   * @throws IllegalArgumentException if the provided string cannot be parsed as an LC Call Number.
   */
  public LCCallNumber(String str) throws IllegalArgumentException {
    Objects.requireNonNull(str);
    // Make sure that we are parsing something that looks like an LC call number and capture the
    // groups
    Matcher matcher = LC_CALLNUMBER_PATTERN.matcher(str);
    if (!matcher.matches()) {
      throw new IllegalArgumentException("does not match LC Call Number pattern: " + str);
    }

    // Retrieving the 1-3 letter subject class is straightforward
    this.subjectClass = CallNumberUtil.nullableTrim(matcher.group(1));

    // Construct the subject number as a decimal value
    String subjectWholeNumber = CallNumberUtil.nullableTrim(matcher.group(2));
    String subjectDecimalNumber = CallNumberUtil.nullableTrim(matcher.group(3));
    this.subjectNumber =
        subjectWholeNumber.isEmpty() && subjectDecimalNumber.isEmpty()
            ? null
            : new BigDecimal(subjectWholeNumber + "." + subjectDecimalNumber);

    // A date or other number (doon?) goes here
    this.preCutter = CallNumberUtil.nullableTrim(matcher.group(4));

    // The first cutter usually begins with a dot followed by a letter and several numbers,
    // but in reality there are a variety of different forms it can take
    this.cutter1 =
        CallNumberUtil.nullableTrimAndConcat(matcher.group(6), matcher.group(7), matcher.group(8));

    // Second cutter
    this.cutter2 =
        CallNumberUtil.nullableTrimAndConcat(
            matcher.group(9), matcher.group(10), matcher.group(11));

    // Third cutter
    this.cutter3 =
        CallNumberUtil.nullableTrimAndConcat(
            matcher.group(12), matcher.group(13), matcher.group(14));

    // An unstructured data set may follow after zero or more cutters
    this.postCutter = CallNumberUtil.nullableTrim(matcher.group(15));

    // Once all the class values are set, we can build the response values for the toString
    // and toNormalizedString methods.  Since this class is immutable, we can do this at
    // construction time to make those methods less expensive.
    this.normalization = buildNormalization();
    this.sortKey = buildSortKey();
  }

  /**
   * Builds and returns the normalized string representation of the call number.
   *
   * @return the normalized string representation
   */
  private String buildNormalization() {
    StringBuilder normalization = new StringBuilder(this.subjectClass);

    if (subjectNumber != null) {
      normalization.append(" ").append(subjectNumber);
    }
    if (!preCutter.isEmpty()) {
      normalization.append(" ").append(preCutter);
    }
    if (!cutter1.isEmpty()) {
      normalization.append(" .").append(cutter1);
    }
    if (!cutter2.isEmpty()) {
      normalization.append(" ").append(cutter2);
    }
    if (!cutter3.isEmpty()) {
      normalization.append(" ").append(cutter3);
    }
    if (!postCutter.isEmpty()) {
      normalization.append(" ").append(postCutter);
    }

    return normalization.toString();
  }

  /**
   * Builds and returns the sortable string representation of the call number.
   *
   * @return the sortable string representation
   */
  private String buildSortKey() {
    StringBuilder sortKey = new StringBuilder(this.subjectClass);

    // We pad the subject number so it sorts correctly
    if (this.subjectNumber != null) {
      sortKey.append(CallNumberUtil.NUMBER_FORMATTER.format(this.subjectNumber));
    }

    if (!this.preCutter.isEmpty()) {
      sortKey.append(" ").append(this.preCutter);
    }

    // The normal cutter may be followed by additional letters and these should sort before numbers
    if (!this.cutter1.isEmpty()) {
      sortKey.append(" ").append(buildSortableCutter(cutter1));
    }

    if (!this.cutter2.isEmpty()) {
      sortKey.append(" ").append(buildSortableCutter(cutter2));
    }

    if (!this.cutter3.isEmpty()) {
      sortKey.append(" ").append(buildSortableCutter(cutter3));
    }

    // Since the postCutter may contain volume or copy information, those numbers should be padded
    // to 6 places
    if (!this.postCutter.isEmpty()) {
      String formattedPostCutter =
          this.postCutter
              .replaceAll("(^|\\W)(\\d+)(\\W|$)", "$1\\0000000000000000$2$3")
              .replaceAll("(^|\\W)00000000+?(\\d{6}+)(\\W|$)", "$1$2$3");
      sortKey.append(" ").append(formattedPostCutter);
    }

    // It is my understanding that non-Latin characters should never be used in LC Call Numbers.
    // However, if
    // they are allowed,replacing the return statement with the commented line below should sort
    // them properly.
    // return Normalizer.normalize(sortKey.toString().toLowerCase(), Normalizer.Form.NFD);
    return sortKey.toString().toLowerCase();
  }

  /**
   * Formats a cutter string to drop any trailing letters so that they sort before numbers (contrary
   * to normal String sorting rules).
   *
   * @param cutter the cutter string to format
   * @return the formatted cutter
   */
  private String buildSortableCutter(String cutter) {
    return cutter.replaceAll("(^|\\w+)(\\d+)(\\w+|$)", "$1$2/$3");
  }

  @Override
  public String sortKey() {
    return sortKey;
  }

  @Override
  public String toString() {
    return normalization;
  }

  @Override
  public int hashCode() {
    return sortKey.hashCode();
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }
    if (obj == null || getClass() != obj.getClass()) {
      return false;
    }

    return Objects.equals(sortKey, ((CallNumber) obj).sortKey());
  }

  /**
   * Returns the subject class.
   *
   * @return the subject class
   */
  public String getSubjectClass() {
    return subjectClass;
  }

  /**
   * Returns the subject number.
   *
   * @return the subject number
   */
  public BigDecimal getSubjectNumber() {
    return subjectNumber;
  }

  /**
   * Returns the pre-cutter text.
   *
   * @return the pre-cutter
   */
  public String getPreCutter() {
    return preCutter;
  }

  /**
   * Returns the first cutter.
   *
   * @return the first cutter
   */
  public String getCutter1() {
    return cutter1;
  }

  /**
   * Returns the second cutter.
   *
   * @return the second cutter
   */
  public String getCutter2() {
    return cutter2;
  }

  /**
   * Returns the third cutter.
   *
   * @return the third cutter
   */
  public String getCutter3() {
    return cutter3;
  }

  /**
   * Returns any text that follows the cutter.
   *
   * @return the post-cutter text
   */
  public String getPostCutter() {
    return postCutter;
  }
}
